// SPDX-FileCopyrightText: 2024 Siemens AG
// SPDX-License-Identifier: Apache-2.0

package v2

import (
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
)

type StreamStatusCode string

const (
	RequestedStatus   StreamStatusCode = "REQUESTED"
	QueuedStatus      StreamStatusCode = "QUEUED"
	ComputedStatus    StreamStatusCode = "COMPUTED"
	EmbeddedStatus    StreamStatusCode = "EMBEDDED"
	UnembeddedStatus  StreamStatusCode = "UNEMBEDDED"
	UnscheduledStatus StreamStatusCode = "UNSCHEDULED"
)

// StreamSpec defines the desired state of Stream
type StreamSpec struct {

	// Source node identifier
	SrcNode string `json:"srcNode"`
	// Destination node identifier
	DstNodes []string `json:"dstNodes"`
	// Packet size, given in bytes
	MaxFrameSize int32 `json:"maxFrameSize"`
	// Transmission period, given in nanoseconds
	Interval int32 `json:"interval"`
	// Required (maximum accepted) end-to-end delay,
	// given in nanoseconds
	MaxLatency int64 `json:"maxLatency"`
	// Start of send window, given in
	// nanoseconds. If not provided, sending time can be at any point
	// during cycle event. Must be a multiplier of 1250. Can be equal
	// to ``latest_transmit_offset``, in this case, it exactly defines
	// the transmission offset.
	EarliestTransmitOffset int32 `json:"earliestTransmitOffset,omitempty"`
	// End of send window, given in
	// nanoseconds. If not provided, sending time can be at any point
	// during cycle event. Can be equal to ``earliest_transmit_offset``,
	// in this case, it exactly defines the transmission offset.
	LatestTransmitOffset int32 `json:"latestTransmitOffset,omitempty"`
	// VLAN identifier within [1; 3999] range except
	// native VLAN ID 1 and test VLAN ID 42. VLAN range 4000-4095 reserved for VLAN-unaware bridging.
	// Each stream should have a unique VLAN ID. If not provided, will be randomly
	// generated by controller.
	VlanId int `json:"vlanId,omitempty"`
	// MAC address of the source node
	SrcNodeMac string `json:"srcNodeMac,omitempty"`
	// MAC address of the destination node
	DstNodeMacs []string `json:"dstNodesMac,omitempty"`
	// The Priority of the stream
	Priority int32 `json:"priority,omitempty"`
	// The Creator of the stream
	Creator string `json:"creator,omitempty"`
	// An identifier of the stream in reverse
	// direction. If provided, then `vlan_id`, `src_node` and
	// `dst_nodes` fields will be inherited from the stream in reverse
	// direction – with source and destination swapped accordingly.
	ReverseStream string `json:"reverseStream,omitempty"`
}

// StreamStatus defines the observed state of Stream
type StreamStatus struct {
	// Status of the Stream
	Status StreamStatusCode `json:"status"`
}

// +kubebuilder:object:root=true
// +kubebuilder:subresource:status
// +kubebuilder:printcolumn:name="Status",type="string",JSONPath=".status.status",description="Status"
// +kubebuilder:printcolumn:name="SrcNode",type="string",JSONPath=".spec.srcNode",description="source node"
// +kubebuilder:printcolumn:name="DstNodes",type="string",JSONPath=".spec.dstNodes",description="destination nodes"
// +kubebuilder:printcolumn:name="MaxFrameSize",type="integer",JSONPath=".spec.maxFrameSize",description="maximum frame size"
// +kubebuilder:printcolumn:name="Interval",type="integer",JSONPath=".spec.interval",description="interval"
// +kubebuilder:printcolumn:name="MaxLatency",type="integer",JSONPath=".spec.maxLatency",description="maximum latency"

// Stream is the Schema for the streams API
type Stream struct {
	metav1.TypeMeta   `json:",inline"`
	metav1.ObjectMeta `json:"metadata,omitempty"`

	Spec   StreamSpec   `json:"spec,omitempty"`
	Status StreamStatus `json:"status,omitempty"`
}

// +kubebuilder:object:root=true

// StreamList contains a list of Stream
type StreamList struct {
	metav1.TypeMeta `json:",inline"`
	metav1.ListMeta `json:"metadata,omitempty"`
	Items           []Stream `json:"items"`
}

func init() {
	SchemeBuilder.Register(&Stream{}, &StreamList{})
}
